#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.20 Project
#

#################################
# GLOBAL VARIABLES
#
global cmdl; 
global in; 
global op1; 
global op2; 
global out; 
global widget; 
    set widget() {.top17.ent18}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {
#Version check
global tk_version;
if {$tk_version < 4.2} {
    puts "enkf needs Tcl7.6/Tk4.2 later version."
    exit
}
}

init $argc $argv


proc {aboutbox} {} {
tk_messageBox -icon info -type ok -title "About Easy Nkf 1.1.2" -message  "Easy Nkf is Enviroment of Kanji code conversion.\n-Free software-\n Copyright (c) 1998 Cow Project Workshop"
}

proc {main} {argc argv} {
global cmdl; 
global in; 
global op1; 
global op2; 
global out; 
#Check mark
.top17.rad18 select
#Load Listbox
set opt {{None} {Add CR} {Delete CR} {Rot13/47} {MIME} {Latin-1 Suport} {X0208 alphabet} {X0201 kana} {Broken input} {Folding}}
foreach i $opt {
 .top17.cpd18.01 insert end $i
}
#Binding Mouse button
bind .top17.cpd18.01 <ButtonRelease-1> {
 bell
 set opsel [.top17.cpd18.01 curselection]
 switch $opsel {
  0
   {set op2 {}}
  1
   {set op2 {-c}}
  2
   {set op2 {-d}}
  3
   {set op2 {-r}}
  4
   {set op2 {-m}}
  5
   {set op2 {-l}}
  6
   {set op2 {-Z0}}
  7
   {set op2 {-X}}
  8
   {set op2 {-B0}}
  9
   {set op2 {-f}}
 }
set cmdl [concat nkf -O $op1 $op2 $in $out]
}
}

proc {Window} {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 200x200+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "enkf.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #70d096 -cursor xterm 
    wm focusmodel $base passive
    wm geometry $base 393x243+102+154
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Easy Nkf Ver.1.1.3"
    label $base.lab18 \
        -background #dbb8db -relief groove -text {Easy Nkf for tcl/tk} 
    message $base.mes19 \
        -justify center -padx 5 -pady 3 -relief sunken \
        -text {Enviroment of Kanji code conversion (C)1998Cow} -width 100 
    button $base.but21 \
        \
        -command {bell
set cmdl [concat nkf -O $op1 $op2 $in $out]
set cmdlexe [concat exec $cmdl]
eval $cmdlexe} \
        -foreground #000000 -padx 9 -pady 3 -text {Start Convert} 
    radiobutton $base.rad17 \
        -command {bell
set cmdl [concat nkf -O $op1 $op2 $in $out]} \
        -relief raised -text jis -value -j -variable op1 
    radiobutton $base.rad18 \
        -command {bell
set cmdl [concat nkf -O $op1 $op2 $in $out]} \
        -relief raised -text euc -value -e -variable op1 
    radiobutton $base.rad19 \
        -command {bell
set cmdl [concat nkf -O $op1 $op2 $in $out]} \
        -relief raised -text sjis -value -s -variable op1 
    label $base.lab20 \
        -relief groove -text To 
    label $base.lab22 \
        -relief groove -text {Input File} 
    label $base.lab23 \
        -relief groove -text option 
    entry $base.ent24 \
        -font Mincho:Helvetica-Bold-12 -textvariable op2 
    button $base.but17 \
        -command exit -padx 9 -pady 3 -text Quit 
    entry $base.ent18 \
        -font Mincho:Helvetica-Bold-12 -justify right -textvariable in 
    label $base.lab19 \
        -relief groove -text {Output File} 
    entry $base.ent20 \
        -font Mincho:Helvetica-Bold-12 -justify right -textvariable out 
    entry $base.ent25 \
        -font Mincho:Helvetica-Bold-12 -state disabled -textvariable cmdl 
    button $base.but18 \
        \
        -command {set types {
    {{All Files} * }
    {{Text Files} {.txt} }
    {{Html Files} {.htm*} }
    {{C Source File} {.c*} }
    {{JIS Files} {.jis} }
    {{EUC Files} {.euc} }
    {{Shift JIS Files} {.sjis} }
}
set in [tk_getOpenFile -filetypes $types -title "Input File" -initialfile $in]
set cmdl [concat nkf -O $op1 $op2 $in $out]} \
        -padx 9 -pady 3 -text browse 
    button $base.but20 \
        -command aboutbox -padx 9 -pady 3 -text about 
    frame $base.cpd18 \
        -borderwidth 1 -height 30 -relief raised -width 30 
    listbox $base.cpd18.01 \
        -width 34 -yscrollcommand {.top17.cpd18.03 set} 
    bind $base.cpd18.01 <ButtonRelease-1> {
        bell
 set opsel [.top17.cpd18.01 curselection]
 switch $opsel {
  0
   {set op2 {}}
  1
   {set op2 {-c}}
  2
   {set op2 {-d}}
  3
   {set op2 {-r}}
  4
   {set op2 {-m}}
  5
   {set op2 {-l}}
  6
   {set op2 {-Z0}}
  7
   {set op2 {-X}}
  8
   {set op2 {-B0}}
  9
   {set op2 {-f}}
 }
set cmdl [concat nkf -O $op1 $op2 $in $out]
    }
    bind $base.cpd18.01 <Double-Button-1> {
        bell
 set opsel [.top17.cpd18.01 curselection]
 switch $opsel {
  0
   {set op2 {}}
  1
   {set op2 {-c}}
  2
   {set op2 {-d}}
  3
   {set op2 {-r}}
  4
   {set op2 {-m}}
  5
   {set op2 {-l}}
  6
   {set op2 {-Z0}}
  7
   {set op2 {-X}}
  8
   {set op2 {-B0}}
  9
   {set op2 {-f}}
 }
set cmdl [concat nkf -O $op1 $op2 $in $out]
    }
    scrollbar $base.cpd18.03 \
        -borderwidth 1 -command {.top17.cpd18.01 yview} -orient vert \
        -width 10 
    button $base.but22 \
        \
        -command {set types {
    {{All Files} * }
    {{Text Files} {.txt} }
    {{Html Files} {.htm*} }
    {{C Source File} {.c*} }
    {{JIS Files} {.jis} }
    {{EUC Files} {.euc} }
    {{Shift JIS Files} {.sjis} }
}
set out [tk_getSaveFile -filetypes $types -title "Output File" -initialfile $out]
set cmdl [concat nkf -O $op1 $op2 $in $out]} \
        -padx 9 -pady 3 -text browse 
    button $base.but19 \
        -command {set nkfchk [concat exec nkf -v]
eval $nkfchk} -padx 9 \
        -pady 3 -text {nkf check} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab18 \
        -x 10 -y 15 -anchor nw -bordermode ignore 
    place $base.mes19 \
        -x 10 -y 40 -width 106 -height 71 -anchor nw -bordermode ignore 
    place $base.but21 \
        -x 205 -y 185 -width 115 -height 28 -anchor nw -bordermode ignore 
    place $base.rad17 \
        -x 35 -y 125 -anchor nw -bordermode ignore 
    place $base.rad18 \
        -x 35 -y 155 -anchor nw -bordermode ignore 
    place $base.rad19 \
        -x 35 -y 185 -anchor nw -bordermode ignore 
    place $base.lab20 \
        -x 10 -y 125 -anchor nw -bordermode ignore 
    place $base.lab22 \
        -x 125 -y 15 -anchor nw -bordermode ignore 
    place $base.lab23 \
        -x 85 -y 125 -anchor nw -bordermode ignore 
    place $base.ent24 \
        -x 275 -y 155 -width 110 -height 24 -anchor nw -bordermode ignore 
    place $base.but17 \
        -x 325 -y 185 -width 59 -height 28 -anchor nw -bordermode ignore 
    place $base.ent18 \
        -x 125 -y 40 -width 260 -height 24 -anchor nw -bordermode ignore 
    place $base.lab19 \
        -x 125 -y 70 -anchor nw -bordermode ignore 
    place $base.ent20 \
        -x 125 -y 95 -width 260 -height 24 -anchor nw -bordermode ignore 
    place $base.ent25 \
        -x 10 -y 215 -width 375 -height 24 -anchor nw -bordermode ignore 
    place $base.but18 \
        -x 325 -y 15 -width 60 -height 23 -anchor nw -bordermode ignore 
    place $base.but20 \
        -x 325 -y 125 -width 60 -height 23 -anchor nw -bordermode ignore 
    place $base.cpd18 \
        -x 125 -y 125 -width 145 -height 55 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd18 0 -weight 1
    grid rowconf $base.cpd18 0 -weight 1
    grid $base.cpd18.01 \
        -in .top17.cpd18 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd18.03 \
        -in .top17.cpd18 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.but22 \
        -x 325 -y 70 -width 60 -height 23 -anchor nw -bordermode ignore 
    place $base.but19 \
        -x 110 -y 185 -anchor nw -bordermode ignore 
}

Window show .
Window show .top17

main $argc $argv
